# Murmur

Docker image for a simple Mumble server (Murmur).

For general documentation, see [the wiki](https://wiki.picasoft.net/doku.php?id=technique:adminserv:mumble:start).

## Configuration
Some environment variables allow to configure Murmur at startup :
- `MAX_BANDWIDTH` : integer, maximum bandwidth clients are allowed speech at (default is `128000` bps)
- `MAX_USERS` : integer, maximum number of users on the server (default is `100`)
- `METRICS_SERVER_LABEL` : Name of this Murmur server to add as metrics label

## Mounted volumes
Murmur store its server database and configuration files under `/data/` folder. You should mount this directory on your host.

Also, Murmur uses a certificate generated by [TLS Certs Monitor](../pica-tls-certs-monitor) : the folder `/DATA/docker/certs/voice.picasoft.net` on the machine should contain the certificate. See the specific documentation.

## Network
Murmur is listening both TCP and UDP on port 64738. You should bind this container port to your host.

## Update

Update the version installed in the Dockerfile and the tag in Compose.
